﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace DecisionMaker
{
    class TrackingdataServer : IConnectionFailed
    {

        //eventhandler connection failed
        event EventHandler connectionFailedEvent;
        object connectionFailedEventLock = new Object();

        event EventHandler IConnectionFailed.OnConnectionFailed
        {
            add
            {
                lock (connectionFailedEventLock)
                {
                    connectionFailedEvent += value;
                }
            }
            remove
            {
                lock (connectionFailedEventLock)
                {
                    connectionFailedEvent -= value;
                }
            }
        }

        private TcpClient tcpClient;
        private IPEndPoint serverEndPoint = new IPEndPoint(IPAddress.Parse("10.0.0.5"), 8001);

        private bool setup;

        private byte[] datamessage = { Convert.ToByte('d'), Convert.ToByte('a'), Convert.ToByte('t'), Convert.ToByte('a') };

        public byte[] message;
        public bool new_message;

        public TrackingdataServer()
        {

            tcpClient = new TcpClient();

            Console.WriteLine("Connecting to TCP server at IP: " + serverEndPoint.Address.ToString());
            if (AttemptConnectToServer() == -1)
            {
                setup = false;

                EventHandler connectionEventHandler = connectionFailedEvent;
                if (connectionEventHandler != null)
                {
                    byte[] m = { Convert.ToByte('t'), Convert.ToByte('r'), Convert.ToByte('a'), Convert.ToByte('c'), Convert.ToByte('k'), Convert.ToByte('i'), Convert.ToByte('n'), Convert.ToByte('g') };
                    connectionEventHandler(this, new ConnectionFailedEventArgs(m));
                }
                return;
            }
            Console.WriteLine("Connect to TCP server succeeded");

            message = new byte[4];
            new_message = false;

            setup = true;
        }

        public bool CheckSetup()
        {
            return setup;
        }

        private int AttemptConnectToServer()
        {
            TimeSpan starttime = (TimeSpan)DateTime.Now.TimeOfDay;
            TimeSpan interval = new TimeSpan(0, 0, 6);

            bool connected = false;
            bool timedout = false;

            while (connected == false && timedout == false)
            {
                if ((TimeSpan)DateTime.Now.TimeOfDay < (starttime + interval))
                {
                    connected = ConnectToServer();
                }
                else
                {
                    timedout = true;
                }
            }

            if (connected == false)
            {
                return -1;
            }
            else
            {
                return 0;
            }
        }

        private bool ConnectToServer()
        {
            try
            {
                if (tcpClient.Connected)
                {
                    tcpClient.Close();
                }

                tcpClient = null;
                tcpClient = new TcpClient();

                tcpClient.Connect(serverEndPoint);

                NetworkStream stream = tcpClient.GetStream();

                stream.Write(datamessage, 0, datamessage.Length);
                stream.Flush();
            }
            catch
            {
                return false;
            }
            return true;
        }

        public int SendTrackingdata(byte[] message)
        {

            try
            {
                NetworkStream stream = tcpClient.GetStream();

                Console.WriteLine("Sending tracking data to TCP server");

                stream.Write(message, 0, message.Length);
                stream.Flush();
            }
            catch
            {
                if (AttemptConnectToServer() == -1)
                {
                    EventHandler connectionEventHandler = connectionFailedEvent;
                    if (connectionEventHandler != null)
                    {
                        byte[] m = { Convert.ToByte('t'), Convert.ToByte('r'), Convert.ToByte('a'), Convert.ToByte('c'), Convert.ToByte('k'), Convert.ToByte('i'), Convert.ToByte('n'), Convert.ToByte('g') };
                        connectionEventHandler(this, new ConnectionFailedEventArgs(m));
                    }
                }
            }

            Console.WriteLine("Message successfully sent\n");

            new_message = false;

            return 0;

        }

    }
}
