
namespace MasterThesis

	public Interface IReportDeadline
	{
		event EventHandler OnDeadlineReached;
	
		class DeadlineReachedEventArgs : EventArgs
		{
			//include classvariable(s) and constructor(s)
		}
	
	}
	
	class MasterThesis : implements IReportDeadline
	{
	
		DateTime deadline = new DateTime(2015, 6, 1, 23, 59, 59);
		
		event EventHandler deadlineReached;
		object deadlineLock = new Object();
		
		event EventHandler IReportDeadline
		{
			add
			{
				lock(deadlineLock)
				{
					deadlineReached += value;
				}
			}
			remove
			{
				lock(deadlineLock)
				{
					deadlineReached -= value;
				}
			}
		}
		
		public void Work()
		{
		
			while(DateTime.Now < deadline)
			{
				//keep working
			}
			
			EventHandler deadlineHandler = deadlineReached;
			
			if(deadlineHandler != null)
			{
				deadlineHandler(this, new EventArgs());
			}
			
		}
	
	}
	
	class ThesisSubmitter
	{
	
		MasterThesis thesis;
		
		IReportDeadline deadlineReachedEvent;
		
		public ThesisSubmitter()
		{
		
			thesis = new MasterThesis();
			
			deadlineReachedEvent = (IReportDeadline)thesis;
			deadlineReachedEvent.OnDeadlineReached += 
						new EventHandler(OnDeadlineReachedEventHandler);
		
		}
		
		void OnDeadlineReachedEventHandler(object o, EventArgs args)
		{
		
			DeadlineReachedEventArgs drargs = (DeadlineReachedEventArgs)args;
			
			Console.WriteLine(drargs.message);
			
			SubmitThesis();
			
		}
		
		private void SubmitThesis()
		{
			//submit thesis
		}
		
	}

}






